C
      SUBROUTINE FRFK(ML,NL,DNS,VP,VS,THK,CV,WN,FRK,FRW,RN,RL,RK
     *               ,RAN,RBN,B11,B12,B13,B14,B21,B22,B23,B24)
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION VP(ML),VS(ML),THK(ML),DNS(ML)
      COMPLEX*16 AA(4,4),SA(4,4),SB(4,4),AAK(4,4),SAK(4,4),SBK(4,4)
     *          ,AAW(4,4),SAW(4,4),SBW(4,4)
     *          ,RAN,RBN,B11,B22,B13,B24,RL,RK,RN,RM
     *          ,RANK,RBNK,B11K,B22K,B13K,B24K,RLK,RKK,RNK,RMK
     *          ,RANW,RBNW,B11W,B22W,B13W,B24W,RLW,RKW,RNW,RMW
C
      CV2=CV*CV
      CK=-CV/WN
      CW=1.D0/WN
C
      DO 120 I=1,4
        DO 130 J=1,4
          AA(I,J) =(0.0D0,0.0D0)
          AAK(I,J)=(0.0D0,0.0D0)
          AAW(I,J)=(0.0D0,0.0D0)
  130   CONTINUE
        AA(I,I)=(1.0D0,0.0D0)
  120 CONTINUE
C
C  ** AA MATRIX **
C
      DO 200 IL=NL-1,1,-1
C
        DO 210 I=1,4
          DO 220 J=1,4
            SA(I,J) =AA(I,J)
            SAK(I,J)=AAK(I,J)
            SAW(I,J)=AAW(I,J)
  220     CONTINUE
  210   CONTINUE
C
C     * CQ, STQ AND SDQ *
C
        BM=VS(IL)
        BM2=BM*BM
        CB2=CV2/BM2
        CALL CSTD(WN,BM,CV,CB2,THK(IL),CQ,STQ,SDQ)
C
C     * CP, STP AND SDP *
C
        AM=VP(IL)
        AM2=AM*AM
        CA2=CV2/AM2
        CALL CSTD(WN,AM,CV,CA2,THK(IL),CP,STP,SDP)
C
C     * CPK,CPW,-,SDQK,SDQW *
C
        CVAK=CV*CK/AM2
        CVAW=CV*CW/AM2
        CVBK=CV*CK/BM2
        CVBW=CV*CW/BM2
C
        RB2=CB2-1.D0
        RA2=CA2-1.D0
        CPK=-THK(IL)*(STP+WN*CVAK*SDP)
        CPW=-THK(IL)*WN*CVAW*SDP
        CQK=-THK(IL)*(STQ+WN*CVBK*SDQ)
        CQW=-THK(IL)*WN*CVBW*SDQ
        STPK=CVAK*SDP+THK(IL)*CP*(RA2+WN*CVAK)
        STPW=CVAW*(SDP+THK(IL)*CP*WN)
        STQK=CVBK*SDQ+THK(IL)*CQ*(RB2+WN*CVBK)
        STQW=CVBW*(SDQ+THK(IL)*CQ*WN)
        SDPK=-CVAK*SDP/RA2+THK(IL)*CP*(1.D0+WN*CVAK/RA2)
        SDPW=CVAW*(-SDP+THK(IL)*CP*WN)/RA2
        SDQK=-CVBK*SDQ/RB2+THK(IL)*CQ*(1.D0+WN*CVBK/RB2)
        SDQW=CVBW*(-SDQ+THK(IL)*CQ*WN)/RB2
C
C     * C11-C16, D11-D15 AND SB MATRIX *
C
        GM=2.D0/CB2
C
        C11=GM
        C12=GM-1.D0
        C13=GM*GM
        C14=C12*C12
        C16=DNS(IL)*CV2
        C15=1.D0/C16
C
        D11=CP-CQ
        D12=SDP+STQ
        D13=STP+SDQ
        D14=C14*SDP+C13*STQ
        D15=C13*STP+C14*SDQ
C
        SB(1,1)= DCMPLX(C11*CP-C12*CQ,0.0D0)
        SB(1,2)= DCMPLX(0.0D0,C12*SDP+C11*STQ)
        SB(1,3)=-DCMPLX(C15*D11,0.D0)
        SB(1,4)= DCMPLX(0.D0,C15*D12)
        SB(2,1)=-DCMPLX(0.0D0,C11*STP+C12*SDQ)
        SB(2,2)= DCMPLX(-C12*CP+C11*CQ,0.D0)
        SB(2,3)= DCMPLX(0.D0,C15*D13)
        SB(2,4)= SB(1,3)
        SB(3,1)= DCMPLX(C16*C11*C12*D11,0.0D0)
        SB(3,2)= DCMPLX(0.D0,C16*D14)
        SB(3,3)= SB(2,2)
        SB(3,4)= SB(1,2)
        SB(4,1)= DCMPLX(0.D0,C16*D15)
        SB(4,2)= SB(3,1)
        SB(4,3)= SB(2,1)
        SB(4,4)= SB(1,1)
C
C     * C11K-C16W, D11K-D15W, SBK AND SBW MATRIX *
C
        GMK=-2.D0*GM*CK/CV
        GMW=-2.D0*GM*CW/CV
C
        C11K=GMK
        C11W=GMW
        C12K=GMK
        C12W=GMW
        C13K=2.D0*GM*GMK
        C13W=2.D0*GM*GMW
        C14K=2.D0*C12*C12K
        C14W=2.D0*C12*C12W
        C16K=2.D0*DNS(IL)*CV*CK
        C16W=2.D0*DNS(IL)*CV*CW
        C15K=-C16K/(C16*C16)
        C15W=-C16W/(C16*C16)
C
        D11K=CPK-CQK
        D11W=CPW-CQW
        D12K=SDPK+STQK
        D12W=SDPW+STQW
        D13K=STPK+SDQK
        D13W=STPW+SDQW
        D14K=C14K*SDP+C14*SDPK+C13K*STQ+C13*STQK
        D14W=C14W*SDP+C14*SDPW+C13W*STQ+C13*STQW
        D15K=C13K*STP+C13*STPK+C14K*SDQ+C14*SDQK
        D15W=C13W*STP+C13*STPW+C14W*SDQ+C14*SDQW
C
        SBK(1,1)= DCMPLX(C11K*CP+C11*CPK-C12K*CQ-C12*CQK,0.0D0)
        SBK(1,2)= DCMPLX(0.0D0,C12K*SDP+C12*SDPK+C11K*STQ+C11*STQK)
        SBK(1,3)=-DCMPLX(C15K*D11+C15*D11K,0.D0)
        SBK(1,4)= DCMPLX(0.D0,C15K*D12+C15*D12K)
        SBK(2,1)=-DCMPLX(0.0D0,C11K*STP+C11*STPK+C12K*SDQ+C12*SDQK)
        SBK(2,2)= DCMPLX(-C12K*CP-C12*CPK+C11K*CQ+C11*CQK,0.D0)
        SBK(2,3)= DCMPLX(0.D0,C15K*D13+C15*D13K)
        SBK(2,4)= SBK(1,3)
        SBK(3,1)= DCMPLX((C16K*C11+C16*C11K)*C12*D11,0.0D0)
        SBK(3,1)= SBK(3,1)+DCMPLX(C16*C11*(C12K*D11+C12*D11K),0.0D0)
        SBK(3,2)= DCMPLX(0.D0,C16K*D14+C16*D14K)
        SBK(3,3)= SBK(2,2)
        SBK(3,4)= SBK(1,2)
        SBK(4,1)= DCMPLX(0.D0,C16K*D15+C16*D15K)
        SBK(4,2)= SBK(3,1)
        SBK(4,3)= SBK(2,1)
        SBK(4,4)= SBK(1,1)
C
        SBW(1,1)= DCMPLX(C11W*CP+C11*CPW-C12W*CQ-C12*CQW,0.0D0)
        SBW(1,2)= DCMPLX(0.0D0,C12W*SDP+C12*SDPW+C11W*STQ+C11*STQW)
        SBW(1,3)=-DCMPLX(C15W*D11+C15*D11W,0.D0)
        SBW(1,4)= DCMPLX(0.D0,C15W*D12+C15*D12W)
        SBW(2,1)=-DCMPLX(0.0D0,C11W*STP+C11*STPW+C12W*SDQ+C12*SDQW)
        SBW(2,2)= DCMPLX(-C12W*CP-C12*CPW+C11W*CQ+C11*CQW,0.D0)
        SBW(2,3)= DCMPLX(0.D0,C15W*D13+C15*D13W)
        SBW(2,4)= SBW(1,3)
        SBW(3,1)= DCMPLX((C16W*C11+C16*C11W)*C12*D11,0.0D0)
        SBW(3,1)= SBW(3,1)+DCMPLX(C16*C11*(C12W*D11+C12*D11W),0.0D0)
        SBW(3,2)= DCMPLX(0.D0,C16W*D14+C16*D14W)
        SBW(3,3)= SBW(2,2)
        SBW(3,4)= SBW(1,2)
        SBW(4,1)= DCMPLX(0.D0,C16W*D15+C16*D15W)
        SBW(4,2)= SBW(3,1)
        SBW(4,3)= SBW(2,1)
        SBW(4,4)= SBW(1,1)
C
C     * AA MATRIX *
C
        DO 250 I=1,4
          DO 260 J=1,4
            AA(I,J)=(0.D0,0.D0)
            AAK(I,J)=(0.D0,0.D0)
            AAW(I,J)=(0.D0,0.D0)
            DO 270 K=1,4
              AA(I,J) =AA(I,J) +SA(I,K)*SB(K,J)
              AAK(I,J)=AAK(I,J)+SAK(I,K)*SB(K,J)+SA(I,K)*SBK(K,J)
              AAW(I,J)=AAW(I,J)+SAW(I,K)*SB(K,J)+SA(I,K)*SBW(K,J)
  270       CONTINUE
  260     CONTINUE
  250   CONTINUE
C
  200 CONTINUE
C
C   * GN,RAN,RBN,B11-B24 AND RL-RM ***
C
      BN2=VS(NL)*VS(NL)
      AN2=VP(NL)*VP(NL)
      GN=2.D0*BN2/CV2
      RANI=DSQRT(1.0D0-CV2/AN2)
      RBNI=DSQRT(1.0D0-CV2/BN2)
      RAN=-DCMPLX(0.D0,RANI)
      RBN=-DCMPLX(0.D0,RBNI)
C
      B11=GN*RAN
      B12=GN-1.D0
      B14=1.D0/(DNS(NL)*CV2)
      B22=GN*RBN
      B13=-RAN*B14
      B21=-B12
      B23=B14
      B24=RBN*B14
C
      RL=B11*AA(1,1)+B12*AA(2,1)+B13*AA(3,1)+B14*AA(4,1)
      RK=B11*AA(1,2)+B12*AA(2,2)+B13*AA(3,2)+B14*AA(4,2)
      RN=B21*AA(1,1)+B22*AA(2,1)+B23*AA(3,1)+B24*AA(4,1)
      RM=B21*AA(1,2)+B22*AA(2,2)+B23*AA(3,2)+B24*AA(4,2)
C
C   * GNK,RANK,RBNK,B11K-B24K AND RLK-RMK ***
C
      GNK=-2.D0*GN*CK/CV
      RANK=CV*CK/(AN2*RAN)
      RBNK=CV*CK/(BN2*RBN)
C
      B11K=GNK*RAN+GN*RANK
      B12K=GNK
      B14K=-2.D0*CK*B14/CV
      B22K=GNK*RBN+GN*RBNK
      B13K=-RANK*B14-RAN*B14K
      B21K=-B12K
      B23K=B14K
      B24K=RBNK*B14+RBN*B14K
C
      RLK=B11K*AA(1,1)+B11*AAK(1,1)+B12K*AA(2,1)+B12*AAK(2,1)
      RLK=RLK+B13K*AA(3,1)+B13*AAK(3,1)+B14K*AA(4,1)+B14*AAK(4,1)
      RKK=B11K*AA(1,2)+B11*AAK(1,2)+B12K*AA(2,2)+B12*AAK(2,2)
      RKK=RKK+B13K*AA(3,2)+B13*AAK(3,2)+B14K*AA(4,2)+B14*AAK(4,2)
      RNK=B21K*AA(1,1)+B21*AAK(1,1)+B22K*AA(2,1)+B22*AAK(2,1)
      RNK=RNK+B23K*AA(3,1)+B23*AAK(3,1)+B24K*AA(4,1)+B24*AAK(4,1)
      RMK=B21K*AA(1,2)+B21*AAK(1,2)+B22K*AA(2,2)+B22*AAK(2,2)
      RMK=RMK+B23K*AA(3,2)+B23*AAK(3,2)+B24K*AA(4,2)+B24*AAK(4,2)
C
C   * GNW,RANW,RBNW,B11W-B24W AND RLW-RMW ***
C
      GNW=-2.D0*GN*CW/CV
      RANW=CV*CW/(AN2*RAN)
      RBNW=CV*CW/(BN2*RBN)
C
      B11W=GNW*RAN+GN*RANW
      B12W=GNW
      B14W=-2.D0*CW*B14/CV
      B22W=GNW*RBN+GN*RBNW
      B13W=-RANW*B14-RAN*B14W
      B21W=-B12W
      B23W=B14W
      B24W=RBNW*B14+RBN*B14W
C
      RLW=B11W*AA(1,1)+B11*AAW(1,1)+B12W*AA(2,1)+B12*AAW(2,1)
      RLW=RLW+B13W*AA(3,1)+B13*AAW(3,1)+B14W*AA(4,1)+B14*AAW(4,1)
      RKW=B11W*AA(1,2)+B11*AAW(1,2)+B12W*AA(2,2)+B12*AAW(2,2)
      RKW=RKW+B13W*AA(3,2)+B13*AAW(3,2)+B14W*AA(4,2)+B14*AAW(4,2)
      RNW=B21W*AA(1,1)+B21*AAW(1,1)+B22W*AA(2,1)+B22*AAW(2,1)
      RNW=RNW+B23W*AA(3,1)+B23*AAW(3,1)+B24W*AA(4,1)+B24*AAW(4,1)
      RMW=B21W*AA(1,2)+B21*AAW(1,2)+B22W*AA(2,2)+B22*AAW(2,2)
      RMW=RMW+B23W*AA(3,2)+B23*AAW(3,2)+B24W*AA(4,2)+B24*AAW(4,2)
C
C      ** FRK,FRW, RG AND RH **
C
      FRK=REAL(RNK*RK+RN*RKK-RLK*RM-RL*RMK)
      FRW=REAL(RNW*RK+RN*RKW-RLW*RM-RL*RMW)
C
      RETURN
      END
